from bot_core.logging.database_logger import DatabaseLogger
from bot_data.abc.migration_abc import MigrationABC
from bot_data.db_context import DBContext


class DefaultRoleMigration(MigrationABC):
    name = "1.1.3_DefaultRoleMigration"

    def __init__(self, logger: DatabaseLogger, db: DBContext):
        MigrationABC.__init__(self)
        self._logger = logger
        self._db = db
        self._cursor = db.cursor

    def upgrade(self):
        self._logger.debug(__name__, "Running upgrade")

        self._cursor.execute(
            str(
                f"""
                    ALTER TABLE CFG_Server
                    ADD DefaultRoleId BIGINT NULL AFTER LoginMessageChannelId;
                """
            )
        )

    def downgrade(self):
        self._cursor.execute(
            str(
                f"""
                    ALTER TABLE CFG_Server DROP COLUMN DefaultRoleId;
                """
            )
        )
