from bot_data.abc.history_table_abc import HistoryTableABC


class TechnicianConfigHistory(HistoryTableABC):
    def __init__(
        self,
        help_command_reference_url: str,
        wait_for_restart: int,
        wait_for_shutdown: int,
        cache_max_messages: int,
        deleted: bool,
        date_from: str,
        date_to: str,
        id=0,
    ):
        HistoryTableABC.__init__(self)

        self._id = id
        self._help_command_reference_url = help_command_reference_url
        self._wait_for_restart = wait_for_restart
        self._wait_for_shutdown = wait_for_shutdown
        self._cache_max_messages = cache_max_messages

        self._deleted = deleted
        self._date_from = date_from
        self._date_to = date_to

    @property
    def help_command_reference_url(self) -> str:
        return self._help_command_reference_url

    @help_command_reference_url.setter
    def help_command_reference_url(self, value: str):
        self._help_command_reference_url = value

    @property
    def wait_for_restart(self) -> int:
        return self._wait_for_restart

    @wait_for_restart.setter
    def wait_for_restart(self, value: int):
        self._wait_for_restart = value

    @property
    def wait_for_shutdown(self) -> int:
        return self._wait_for_shutdown

    @wait_for_shutdown.setter
    def wait_for_shutdown(self, value: int):
        self._wait_for_shutdown = value

    @property
    def cache_max_messages(self) -> int:
        return self._cache_max_messages

    @cache_max_messages.setter
    def cache_max_messages(self, value: int):
        self._cache_max_messages = value
