from cpl_core.database import TableABC

from bot_graphql.abc.query_abc import QueryABC


class DataQueryABC(QueryABC):
    def __init__(self, name: str):
        QueryABC.__init__(self, name)

        self.set_field("createdAt", self.resolve_created_at)
        self.set_field("modifiedAt", self.resolve_modified_at)

    @staticmethod
    def resolve_created_at(entry: TableABC, *_):
        return entry.created_at

    @staticmethod
    def resolve_modified_at(entry: TableABC, *_):
        return entry.modified_at
