from cpl_core.database.context import DatabaseContextABC

from bot_data.model.user_joined_server import UserJoinedServer
from bot_data.model.user_joined_server_history import UserJoinedServerHistory
from bot_graphql.abc.data_query_with_history_abc import DataQueryWithHistoryABC


class UserJoinedServerQuery(DataQueryWithHistoryABC):
    def __init__(self, db: DatabaseContextABC):
        DataQueryWithHistoryABC.__init__(
            self, "UserJoinedServer", "UserJoinedServersHistory", UserJoinedServerHistory, db
        )

        self.set_field("id", self.resolve_id)
        self.set_field("user", self.resolve_user)
        self.set_field("joinedOn", self.resolve_joined_on)
        self.set_field("leavedOn", self.resolve_leaved_on)

    @staticmethod
    def resolve_id(x: UserJoinedServer, *_):
        return x.id

    @staticmethod
    def resolve_user(x: UserJoinedServer, *_):
        return x.user

    @staticmethod
    def resolve_joined_on(x: UserJoinedServer, *_):
        return x.joined_on

    @staticmethod
    def resolve_leaved_on(x: UserJoinedServer, *_):
        return x.leaved_on
