from cpl_core.configuration import ConfigurationABC
from cpl_core.logging import LoggerABC
from cpl_discord.events import OnReadyABC
from cpl_discord.service import DiscordBotServiceABC

from bot_core.service.config_service import ConfigService
from bot_data.abc.server_repository_abc import ServerRepositoryABC


class ConfigOnReadyEvent(OnReadyABC):
    def __init__(
        self,
        config: ConfigurationABC,
        logger: LoggerABC,
        bot: DiscordBotServiceABC,
        servers: ServerRepositoryABC,
        config_service: ConfigService,
    ):
        OnReadyABC.__init__(self)

        self._config = config
        self._logger = logger
        self._bot = bot
        self._servers = servers
        self._config_service = config_service

    async def on_ready(self):
        for guild in self._bot.guilds:
            await self._config_service.reload_server_config(self._servers.get_server_by_discord_id(guild.id))
