from cpl_discord.service import DiscordBotServiceABC

from bot_data.abc.data_seeder_abc import DataSeederABC
from modules.short_role_name.service.short_role_name_service import ShortRoleNameService


class ShortRoleNameSeeder(DataSeederABC):
    def __init__(
        self,
        bot: DiscordBotServiceABC,
        short_role_name_service: ShortRoleNameService,
    ):
        DataSeederABC.__init__(self)

        self._bot = bot
        self._short_role_name_service = short_role_name_service

    async def seed(self):
        for guild in self._bot.guilds:
            for member in guild.members:
                await self._short_role_name_service.check_short_role_names(member)
